EMF-REST
========

What is EMF-REST?
-----------------

EMF-REST generates truly RESTful APIs for your EMF models. EMF-REST complements the existing (Java-based) API generation facilities EMF already provides and extends them to the Web.

Thanks to EMF-REST, web developers can quickly get a JSON-based RESTful API derived from their models plus a JavaScript library to simplify the interaction with the API.

* EMF-REST automatically creates a RESTful API conforming to the JAX-RS specification that can be automatically deployed in your application server.Generation of REST services in the server based on the Java JAX-RS specification.
* All the communication with the API is done via JSON objects. Currently, these objects are then stored as XML files in the server.
* EMF-REST also generates a JavaScript library to facilitate the management of the API on the client-side (e.g. use of the dot notation for navigation).

What is coming next?
--------------------

We are currently working hard on:

* Support for POST / DELETE / PUT http methods
* Tuning the way objects are represented in JSON

Who is behind EMF-REST?
-----------------------
* [Camilo Alvarez](http://github.com/cadorca/ "Camilo Alvarez")
* [Javier Canovas](http://github.com/jlcanovas/ "Javier Canovas")
* [Jordi Cabot](http://github.com/jcabot/ "Jordi Cabot")

Can I collaborate?
------------------

Absolutely!. EMF-REST is licensed under the EPL license so feel free to contribute. 

How can I follow the latest news about EMF-REST?
------------------------------------------------

All major announcements will be posted in the [modeling-languages.com](http://modeling-languages.com "modeling-languages.com") portal. You can also follow our [@softmodeling](https://twitter.com/softmodeling "@softmodeling") and [@jlcanovas](https://twitter.com/jlcanovas "@jlcanovas") twitter accounts for updates (or just [email us](mailto:emf-rest@modeling-languages.com "email us") whenever you want). And check also the [AtlanMod](http://www.emn.fr/z-info/atlanmod/index.php/Main_Page "AtlanMod") team page. 