/**
 */
package Example.util;

import Example.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see Example.ExamplePackage
 * @generated
 */
public class ExampleAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static ExamplePackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExampleAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = ExamplePackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExampleSwitch<Adapter> modelSwitch =
    new ExampleSwitch<Adapter>()
    {
      @Override
      public Adapter caseFamily(Family object)
      {
        return createFamilyAdapter();
      }
      @Override
      public Adapter caseMember(Member object)
      {
        return createMemberAdapter();
      }
      @Override
      public Adapter caseParent(Parent object)
      {
        return createParentAdapter();
      }
      @Override
      public Adapter caseSon(Son object)
      {
        return createSonAdapter();
      }
      @Override
      public Adapter caseDaughter(Daughter object)
      {
        return createDaughterAdapter();
      }
      @Override
      public Adapter casePet(Pet object)
      {
        return createPetAdapter();
      }
      @Override
      public Adapter caseDog(Dog object)
      {
        return createDogAdapter();
      }
      @Override
      public Adapter caseCat(Cat object)
      {
        return createCatAdapter();
      }
      @Override
      public Adapter caseRaceDog(RaceDog object)
      {
        return createRaceDogAdapter();
      }
      @Override
      public Adapter caseHuntingDog(HuntingDog object)
      {
        return createHuntingDogAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link Example.Family <em>Family</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Family
   * @generated
   */
  public Adapter createFamilyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Member <em>Member</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Member
   * @generated
   */
  public Adapter createMemberAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Parent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Parent
   * @generated
   */
  public Adapter createParentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Son <em>Son</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Son
   * @generated
   */
  public Adapter createSonAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Daughter <em>Daughter</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Daughter
   * @generated
   */
  public Adapter createDaughterAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Pet <em>Pet</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Pet
   * @generated
   */
  public Adapter createPetAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Dog <em>Dog</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Dog
   * @generated
   */
  public Adapter createDogAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.Cat <em>Cat</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.Cat
   * @generated
   */
  public Adapter createCatAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.RaceDog <em>Race Dog</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.RaceDog
   * @generated
   */
  public Adapter createRaceDogAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link Example.HuntingDog <em>Hunting Dog</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see Example.HuntingDog
   * @generated
   */
  public Adapter createHuntingDogAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //ExampleAdapterFactory
